/* Declare xwinapp.cc */



class CXWindowApp {

   // Used for palette emulation:

   // one RGB struct 
   struct tagRGB {
      DWORD dwR;
      DWORD dwG;
      DWORD dwB;
   };
  
   // for 16BPP
   union tagFormat16 {

      struct {
         unsigned bitsB : 5;
         unsigned bitsG : 6;
         unsigned bitsR : 5;
      } stBits;

      int nValue;
   };
  
   // for 15BPP
   union tagFormat15 {

      struct {
         unsigned bitsA : 1;
         unsigned bitsB : 5;
         unsigned bitsG : 5;
         unsigned bitsR : 5;
      } stBits;

      int nValue;
   };
      
public:

   CXWindowApp ();
   ~CXWindowApp ();

public:

   // X app data
   Display*     m_pstDisplay;
   XtAppContext m_stApContext;
   Widget       m_stTopLevel;
   Widget       m_stShell;
   Widget       m_stBox;

   // hole screen
   // video resolution
   int m_nDpyWidth;
   int m_nDpyHeight;
   // color depth (bits per pixel)
   int m_nBpp;

   // window data
   int m_nScreenNum;
   Window   m_stWindow;
   XImage*  m_pXImg;
   GC       m_stGC;
   BYTE*    m_pyVid;     // point the aplication window frame buffer
   DWORD    m_dwResX;    // window X resolution
   DWORD    m_dwResY;    // window Y resolution
   BYTE*    m_pyVidPal;  // point the buffer for video memory, under palette (8BPP) mode
                         // At more then 8BPP is used for palette mode emulation.
                         // This is the user frame buffer.

   #ifdef COMP_SHAREMEMORY
   XShmSegmentInfo m_stShmi;
   XImage m_stShmImg;
   #endif

   // palette
   Colormap m_stColorMap;         // the palette, for 8BPP
   tagRGB   m_astPalEmul [ 256 ]; // store the palette for emulation at more than 8BPP
     
   // input
   CKeyboard m_oKb;          // set keyboard functions acording keyboard events

public:

   void mCreate ( char* szWintitle, DWORD dwResX, DWORD dwResY, int nArgc, char* pszArgv [] );
   void mDestroy ();
   void mWritePal ( BYTE* payMem );
   void mShow ();
   void mExecApp ();

   // for palette emulation
   DWORD mFormatPixelColor ( DWORD dwPalCol );
};

